#version 130

// Model-View-Projection
uniform mat4 MVPMatrix;
uniform mat4 WorldMatrix;
uniform mat4 MatrixList[100];

// \ʍގ
uniform vec4 Ambient = vec4( 0.2, 0.2, 0.2, 1.0 );
uniform vec4 Diffuse = vec4( 1.0, 1.0, 1.0, 1.0 );

// 
uniform vec3 LightIntensity = vec3(1.0, 1.0, 1.0);
uniform vec3 LightDir       = vec3(5.0, 4.0, 0.0);


// 
in  vec4  Position;
in  vec3  Normal;
in  float Index;

// o
out vec4 VertexColor;

void main() {
     int index = int(Index);
     vec3 normal     = mat3(WorldMatrix * MatrixList[index]) * Normal;
     gl_Position     = MVPMatrix * MatrixList[index] * Position;

     vec3 light      = normalize( LightDir );
     float diffuse   = clamp( dot( light, normal ), 0, 1 );
     VertexColor.rgb = Ambient.rgb*0.4 + Diffuse.rgb * LightIntensity * diffuse;
     VertexColor.a   = Diffuse.a;
}
