/** @file static__lambert.vert
 *  @brief X^eBbNbVio[gˁj
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#version 130

uniform mat4 MVPMatrix;
uniform mat4 WorldMatrix;

uniform vec4 Ambient = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec4 Diffuse = vec4(1.0, 1.0, 1.0, 1.0);

uniform vec3 LightDir = vec3(0.0, 1.0, 0.0);
uniform vec3 LightIntensity = vec3(1.0, 1.0, 1.0);

in  vec4 Position;
in  vec3 Normal;
in  vec2 UV0;

out vec2 TexCoord;

out vec4 VertexColor;

void main() {
     gl_Position     = MVPMatrix * Position;
     vec3 normal     = mat3(WorldMatrix) * Normal;
     vec3 light      = normalize( LightDir );
     float diffuse   = dot( light, normal );
     VertexColor.rgb = Ambient.rgb + Diffuse.rgb * diffuse;
     VertexColor.a   = Diffuse.a;
     TexCoord        = UV0;
}
